<?php
/**
* ===================================================
* @author
* Name: Kishore
* Email: kishore@kishoreweblabs.com
* Url: http://www.kishoreweblabs.com
* ===================================================
* @copyright Copyright (C) 2015 kishoreweblabs (http://www.kishoreweblabs.com). All rights reserved.
@license see http://www.gnu.org/licenses/gpl-3.0.html GNU/LGPL Version 3.
* You can use, redistribute this file and/or modify it under the terms of the GNU Lesser General Public License version 3
*The user are free to edit and change  the content of file.
I hereby declare no warranty or loss to anybody using this code.
*/


defined( 'SOBIPRO' ) || exit( 'Restricted access' );

SPLoader::loadController( 'section' );
SPLoader::loadController( 'controller' );
 
class SPPaypaladvCtrl extends SPController
{

	protected $_debug=0;
	protected $_type = 'paypaladv';

	
	public function execute()
	{
	$this->loadPaypalSetting();
	$r = false;
		switch ( $this->_task ) {
		case 'cancel':
		$this->cancel();
		break;
		case 'redirect':
		$this->redirect_paypal();
		break;
		case 'return':
		$this->return_url();
		break;
		case 'ipn':
		$this->ipn();
		break;
		default:
		$r=true;
		//echo 'Default No Task';
		break;
		}
		
		return $r;
	}
		
	 function logData( $action, $message = null,$model )
	{
				if ( Sobi::Cfg( 'entry.versioning', true ) ) {
				
				
				$changes = $model->getCurrentBaseData();
			$fields = $model->getFields();
			if ( count( $fields ) ) {
				foreach ( $fields as $nid => $field ) {
					try {
						$changes[ 'fields' ][ $nid ] = $field->saveHistory();
					} catch ( SPException $x ) {
						$changes[ 'fields' ][ $nid ] = $field->getRaw();
					}
				}
			}
			
			
		
				$sid=$model->get( 'id' );
				$owner = $this->_model->get( 'owner' );
				$user = JFactory::getUser($owner);		
				$data = array(
						'revision' => microtime( true ) . '.' . $sid . '.' . $owner,
						'changedAt' => 'FUNCTION:NOW()',
						'uid' => $owner,
						'userName' =>$user->name,
						'userEmail' =>  $user->email,
						'change' => $action,
						'site' => defined( 'SOBIPRO_ADM' ) ? 'adm' : 'site',
						'sid' => $model->get( 'id' ),
						'changes' => SPConfig::serialize( $changes ),
						'params' => null,
						'reason' => $message,
						'language' => Sobi::Lang()
				);
				SPFactory::db()->insert( 'spdb_history', $data );
			}
		
	
	}
		
	public function publishEntry($sid){
	
	$db = JFactory::getDbo();
		$this->_type ='entry';
		$this->setModel( SPLoader::loadModel( 'entry') );
		$this->_model->init( $sid);
		$this->_model->getRequest( $this->_type );
		//  $this->_model->get( 'owner' );
		// $this->_model->get( 'approved' );//always get 1 so using query to get exact 
		
		$entry= SPFactory::db()
					->select( 'state,approved', 'spdb_object', array( 'id' => $sid ) )
					->loadObject();
		 		
				if($entry->approved==0){ // if it is not already approved , then approve it 
		SPFactory::db()->update( 'spdb_object', array( 'approved' => 1 ), array( 'id' => $sid, 'oType' => 'entry'  ) );
		$this->_model->approveFields( true );
		$this->logData('approve',"Auto Approved from ipn",$this->_model);
	}
		if($entry->state==0){ // if it is not already published, then publish it 
		//	$this->_model->changeState( 1,"Auto published from ipn",0 );// publishing the item  but will not trigger the other applications
		$this->_model->changeState( 1,"Auto published from ipn" );// publishing the item 
		$this->logData('change-state',"Auto Published from ipn",$this->_model);		
			}
			
			
		 $validUntil=	date( 'Y-m-d H:i:s', time() + ( Sobi::Cfg( 'entry.publish_limit', 0 ) * 24 * 3600 ) );
		 if($this->order['order_type'] =='Renew'){
		 
		 $res= SPFactory::db()->select( 'validUntil', 'spdb_object', array( 'id' => $sid ) )->loadObject();
		  $validUntil=	  strtotime($res->validUntil. ' UTC')+ (Sobi::Cfg( 'entry.publish_limit', 0 ) * 24 * 3600 );
		  $validUntil= date( 'Y-m-d H:i:s',   $validUntil );
		  
			  
		  	$this->logData( 'renewed', 'Auto Renewed from ipn' ,$this->_model);
			
		SPFactory::db()->update( 'spdb_object', array( 'validUntil' =>  $validUntil  ), array( 'id' => $sid) ) ;
		SPFactory::db()->update( 'spdb_expiration', array( 'renewed' => 'FUNCTION:NOW()' ), array( 'sid' => $sid) );
			$this->_model->approveFields( true );


		$messageData = array();
		$messageData[ 'entry' ] = $this->_model;
		$messageData[ 'author' ] = SPFactory::Instance( 'cms.base.user', $this->_model->get( 'owner' ) );
		Sobi::Trigger( 'AppexpirationOnAfter', 'Renewal', array( &$messageData ) ); 
			
		 
		  
		 }		
		 
						$row = array(	
								'refNum'=>$this->order['refNum'],
								'datePaid'=>date( 'Y-m-d H:i:s'),
								'paid'=>1
								);
									if(Sobi::Cfg( 'entry.publish_limit', 0 )){
									$row['validUntil']=$validUntil;	}
									
						$row = (object) $row;
						$db->updateObject( '#__sobipro_payments', $row,'refNum' ); 
		 
			
	$entry=SPFactory::Entry($sid);
	$this->entry=$entry;
	$this->values['entry'] = $entry;
	
	
	
	}
	function savePayment(){
	
		$sid=$this->order['sid'];
		$db = JFactory::getDbo();
		
	
		$txn_id = @$_POST['txn_id'];
		$mc_gross = @$_POST['mc_gross'];
		/*	$this->_debug=1;
		if($this->_debug==1){
			$txn_id =rand(100000,99999999);
			$mc_gross =125;
			}*/
		
										
			if($this->order['amount']==$mc_gross){
	 	
			$row = array(	'id'=>$this->order['id'],
								'status' =>'Confirmed',
								'txn'=>$txn_id,
								'order_update_date'=>date( 'Y-m-d H:i:s'),
								'ipn_data'=>serialize($_POST),
								'amount_paid'=>$mc_gross
								);
						$row = (object) $row;
						$db->updateObject( '#__sobipro_paypaladv_orders', $row,'id' );
						
						
			$order= SPFactory::db()->select( '*', 'spdb_paypaladv_orders', array( 'id' => $this->order['id'] ) )->loadAssoc();
			$this->order=$order;		
			$this->values['order']=$this->order;		
						
						$data=array('id'=>'',
									'order_id'=>$this->order['id'],
									'status'=>'Confirmed',
									'date_added'=>date( 'Y-m-d H:i:s'),
									'txn'=>$txn_id
									
						);
						$data = (object) $data;
						$db->insertObject( '#__sobipro_paypaladv_orders_history', $data );
						
					
				
					
					
						
						
						$this->publishEntry($sid);
					
					/*$row = array(	
								'refNum'=>$this->order['refNum'],
								'datePaid'=>date( 'Y-m-d H:i:s'),
								'paid'=>1
								);
									if(Sobi::Cfg( 'entry.publish_limit', 0 )){
									$row['validUntil']= date( 'Y-m-d H:i:s', time() + ( Sobi::Cfg( 'entry.publish_limit', 0 ) * 24 * 3600 ) );
					
					}
						$row = (object) $row;
						$db->updateObject( '#__sobipro_payments', $row,'refNum' );*/
						
						$this->sendConfirmationEmail();
			
	
			}else{// what to do with parital payment don't publish
			
			
	}
	
	
	}
	
	function sendConfirmationEmail(){
	$db = JFactory::getDbo();
	$order_email= SPFactory::db()
					->select( '*', 'spdb_paypaladv_orders_email', array( 'order_id' => $this->order['id'],'email_type'=>'Confirm' ) )
					->loadObject();
					
					if($order_email && $order_email->email_sent==1){
					return ;
					}
					
			$mailer = JFactory::getMailer();
			$amailer = JFactory::getMailer();
			$config = JFactory::getConfig();
			$sender = array( 
				$config->get( 'mailfrom' ),
				$config->get( 'fromname' ) 
			);		
		
		$email_data=array(
	'order_id'=>$this->order['id'],
	'email_type'=>'Confirm',
	'date_added'=>date( 'Y-m-d H:i:s')
	
	);
		
		$paypal_email=array();
		$paypal_email_admin=array();
		if (  $this->order['order_type'] =='New') {
							
							$paypal_email['subject']=$this->paypal_setting['paypal_new_confirm_email_subject'];
							$paypal_email['content']=$this->paypal_setting['paypal_new_confirm_email_temp'];
							$paypal_email_admin['subject']=$this->paypal_setting['paypal_new_confirm_email_subject_admin'];
							$paypal_email_admin['content']=$this->paypal_setting['paypal_new_confirm_email_temp_admin'];
			}elseif($this->order['order_type'] =='Update'){  
							
							$paypal_email['subject']=$this->paypal_setting['paypal_update_confirm_email_subject'];
							$paypal_email['content']=$this->paypal_setting['paypal_update_confirm_email_temp'];
							$paypal_email_admin['subject']=$this->paypal_setting['paypal_update_confirm_email_subject_admin'];
							$paypal_email_admin['content']=$this->paypal_setting['paypal_update_confirm_email_temp_admin'];
						
			}elseif($this->order['order_type'] =='Renew'){  
							
							$paypal_email['subject']=$this->paypal_setting['paypal_renew_confirm_email_subject'];
							$paypal_email['content']=$this->paypal_setting['paypal_renew_confirm_email_temp'];
							$paypal_email_admin['subject']=$this->paypal_setting['paypal_renew_confirm_email_subject_admin'];
							$paypal_email_admin['content']=$this->paypal_setting['paypal_renew_confirm_email_temp_admin'];
						
			}
		
		
		if($this->paypal_setting['from_email']){
		$sender[0]=trim($this->paypal_setting['from_email']);
		}
		
		if($this->paypal_setting['from_name']){
		$sender[1]=trim($this->paypal_setting['from_name']);
		}
					
					
									// user email			
							if($this->paypal_setting['paypal_enable_email']==1){
								
								$paypal_email['type']='user';
								
								 $this->parseVar($paypal_email);
								
								
								$this->callPlugin('BeforePaypalConfirmEmail',$paypal_email);
									 ($paypal_email['content']);
											
										$recipient = $this->order['email'];
										 
										$mailer->addRecipient($recipient);
									
										$mailer->setSubject($paypal_email['subject']);
										$mailer->setBody( $paypal_email['content']);
										$mailer->isHTML(true);
													$send = $mailer->Send();
													if ( $send !== true ) {
															$paypal_email['email_sent']=0;
													   // echo 'Error sending email: ' . $send->__toString();
													} else {
													$paypal_email['email_sent']=1;
													   
													}
													
								$email_data['email_subject']=$paypal_email['subject'];
								$email_data['email_content']=$paypal_email['content'];
							
							
							}

								if($this->paypal_setting['paypal_enable_email_admin']==1){
									
									$paypal_email_admin['type']='admin';
									 
									 $this->parseVar($paypal_email_admin);
									
									
									$this->callPlugin('BeforePaypalConfirmEmail',$paypal_email_admin);
										 ($paypal_email_admin['content']);
									
								
								
											$recipient=explode(',',$this->paypal_setting['paypal_email_admin']);
											
											
											// paypal_email_admin
											$amailer->addRecipient($recipient);
										
											$amailer->setSubject($paypal_email_admin['subject']);
											$amailer->setBody( $paypal_email_admin['content']);
										$amailer->isHTML(true);
														$send = $amailer->Send();
														if ( $send !== true ) {
																$paypal_email_admin['email_sent']=0;
														   // echo 'Error sending email: ' . $send->__toString();
														} else {
														$paypal_email_admin['email_sent']=1;
														   
														}
														
									$email_data['admin_email_subject']=$paypal_email_admin['subject'];
									$email_data['admin_email_content']=$paypal_email_admin['content'];
								
								
								}


					$email_data['email_sent']=0;
					if( (isset($paypal_email_admin['email_sent']) && $paypal_email_admin['email_sent']) || (isset($paypal_email['email_sent']) && $paypal_email['email_sent'])){
						$email_data['email_sent']=1;
						}
							$email_data = (object) $email_data;
												
						if($order_email && $order_email->id){
						$email_data->id=$order_email->id;
						$db->updateObject( '#__sobipro_paypaladv_orders_email', $email_data,'id' );
						}else{
						$db->insertObject( '#__sobipro_paypaladv_orders_email', $email_data );
						}


	

			
	
	}
	function callPlugin($func,&$data){
	
	//BeforePaypalConfirmEmail
	
	}


	function loadPaypalSetting(){
	$db=JFactory::getDBO();
	SPLang::load( 'SpApp.paypaladv' );
		$pdata = SPFactory::registry()
				->loadDBSection( 'paypaladv_' . Sobi::Section() )
				->get( 'paypaladv_' . Sobi::Section() );
			
				$data= array();
				foreach($pdata as $k=>$v){
				 $data[$k]=$pdata[$k]['value'];
				}
				
				
				
			$query="Select * from #__sobipro_paypaladv_setting where lang_type ='lang'";
			$db->setQuery($query);
			$rows=$db->loadAssocList();
			
			foreach($rows  as $row){
					$data[$row['name']]=SPLang::getValue( $row['name'], 'application', Sobi::Section() );
					
				}
			
			
				
			 
			 
			 
			  $this->_debug=$data['paypal_sandbox'];
			
			 
			 
			
			$order_id=JRequest::getInt('order_id');
			
			$order= SPFactory::db()->select( '*', 'spdb_paypaladv_orders', array( 'id' => $order_id ) )->loadAssoc();
			$this->order=$order;
			if(!$order['id']){
			
			Sobi::Error( 'SPPaymentBt', 'Order not found', SPC::WARNING, 404, __LINE__, __FILE__ );
			
			}
		
			$data['user_field_name']=$order['contact_name'];
			$data['user_field_email']=$order['email'];
			
			 $this->paypal_setting=$data;
			
			// delete sobi order from session
			$session = JFactory::getSession();
			$session->set('sobi_order_id_'.$order_id, 0);
			$session->set('sobi_order_saved_'.$order_id,0);	
			
			$config = JFactory::getConfig();
			$payment_url=trim(JURI::ROOT(),'/').'/index.php?option=com_sobipro&sid='.$order['sid'].'&task=paypaladv.redirect&order_id='.$order_id;
	
	
	 	$this->_type ='entry';
	$this->setModel( SPLoader::loadModel( 'entry') );
		
	
		$sid=$order['sid'];
	$entry=SPFactory::Entry($sid);
	$this->entry=$entry;
	
			  $this->values = array(
            'entry' => $entry,
            'amount' => $order['amount'],
			'order'=>$order,
			'live_site'=>trim(JURI::ROOT(),'/'),
		//	'payment'=>$payment ,
			'section_url'=>trim(JURI::ROOT(),'/').Sobi::Url( array( 'sid' => Sobi::Reg( 'current_section' ) ) ) ,
			'payment_url'=>$payment_url,
			'sitename'=>$config->get('sitename')
			
        );
			 
	}
	
	function parseVar(&$data){
	
	if(is_array($data)){
			foreach($data as $k=>$v){
			$data[$k]=SPLang::replacePlaceHolders($v,$this->values);
			}
	}else{
	$data=SPLang::replacePlaceHolders($data,$this->values);
	}
	
	}
	
	
	public function cancel(){
	
	$this->parseVar( $this->paypal_setting['paypal_cancel_trans']);
	echo $this->paypal_setting['paypal_cancel_trans'];
	}
	
	
	public function return_url (){
	
	//'paypal_success_trans', 'paypal_pending_trans', 'paypal_failed_trans', 'paypal_cancel_trans'
	if($this->order['status']=='Confirmed'){
	$this->parseVar( $this->paypal_setting['paypal_success_trans']);
	$cont= $this->paypal_setting['paypal_success_trans'];
	}elseif($this->order['status']=='Pending'){
	
	$this->parseVar( $this->paypal_setting['paypal_pending_trans']);
	$cont= $this->paypal_setting['paypal_pending_trans'];
	}else{
	$this->parseVar( $this->paypal_setting['paypal_failed_trans']);
	$cont= $this->paypal_setting['paypal_failed_trans'];
	}
	
	
	echo $cont;
	
	}
	
	
	function redirect_paypal(){
	
	if($this->order['status']=='Confirmed'){
	 $url='{entry.url}';
	$this->parseVar($url);
	$this->response( $url, Sobi::Txt('PAYPALADV_ALREADY_PAID'), false, SPC::SUCCESS_MSG );
		
		}else{
		
		$document = JFactory::getDocument();
 
 $script='
   jQuery(document).ready(function(){
   
   jQuery("#paypaladv-form .img").hide();
  setTimeout(jQuery("#paypaladv-form .img").click(), 4000);
 
	
});
';
// Add Javascript
$document->addScriptDeclaration($script);
echo  Sobi::Txt( 'PAYPALADV_WAIT_MESSAGE');
echo $this->order['form_data'];
		
		}
	
	
	}
	
	
	public function ipn()
	{
//$this->savePayment();
//exit;		
	
		jimport('joomla.filesystem.file');
	$database=Jfactory::getDBO();
	$path= JPATH_ROOT."/components/com_sobipro/ipn/";
	$path_ipn="ipn.txt";
	$path_curl="error_curl.txt";
	$path_error="error_ipn.txt";
	
	
	$this->logfile($path_ipn,"request recived");
	
	
if(count($_POST)<1 ){
$this->logfile($path_error,"No Post Data send, A hacking attempt");
Sobi::Error( 'entry', SPLang::e( 'UNAUTHORIZED_ACCESS' ), SPC::ERROR, 403, __LINE__, __FILE__ );
return ;
}
// read the post from PayPal system and add 'cmd'
$req = 'cmd=_notify-validate';
foreach ($_POST as $key => $value) {
if (get_magic_quotes_gpc()){
$value = urlencode(stripslashes($value));
}else{
$value = urlencode($value);
}
$req .= "&$key=$value";
}

if($this->_debug){
						$hostname="https://www.sandbox.paypal.com/cgi-bin/webscr";
						
						}else{
							$hostname="https://www.paypal.com/cgi-bin/webscr";
						
		}

$ch = curl_init($hostname);
    curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
    curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));

    if( !($res = curl_exec($ch)) ) {
       
		$this->logfile($path_curl,"Got " . curl_error($ch) . " when processing IPN data");
        curl_close($ch);
        exit;
    }
    curl_close($ch);

						
		

	
						
						
						if (strcmp ($res, "VERIFIED") == 0) {
						
						$this->logfile($path_ipn,"Verified \n");
						
						
							$this->savePayment();
					
						Jexit();
						}else if (strcmp ($res, "INVALID") == 0) {
						$this->logfile($path_error,$req);
						
						}else{
						$this->logfile($path_error,$res);
						}
		
		Jexit();

		
	}
	
	//  function is useful for tracking ipn request
	function logfile($file_name,$data){
	
	
	if(!$this->_debug){
	return;
	}
	$date = JFactory::getDate();
	 $path= JPATH_ROOT."/components/com_sobipro/ipn/";
		
		if (!file_exists($path)) {
    mkdir($path, 0777, true);
}
		$f=fopen($path.$file_name,'a');
		fwrite($f,"\n");
		fwrite($f,"----------".$date->format( 'Y-m-d H:i:s' )."-------------");
		fwrite($f,"\n");
		fwrite($f,$data);
		fwrite($f,"\n");
		fwrite($f,"------------------------------------------------");
		fwrite($f,"\n");
		fclose($f);
	
	}
}//class
?>